



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>FZYZOJ-1578 [NOIP福建夏令营]数列分段</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">FZYZOJ-1578 [NOIP福建夏令营]数列分段</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:39:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>P1578 -- [NOIP福建夏令营]数列分段</h2>
<p>时间限制：1000MS &nbsp;&nbsp;&nbsp;&nbsp; 内存限制：131072KB</p>
<p>状态：Accepted &nbsp;&nbsp;&nbsp;&nbsp; 标签： &nbsp;&nbsp;&nbsp;二分&nbsp;&nbsp;&nbsp;无&nbsp;&nbsp;&nbsp;无</p>
<h3>Description</h3>
<p>对于给定的一个长度为N的正整数数列A[i]，现要将其分成M（M&le;N）段，并要求每段连续，且每段和的最大值最小。</p>
<p>关于最大值最小：</p>
<p>例如一数列4 2 4 5 1要分成3段</p>
<p>将其如下分段：[4 2][4 5][1]</p>
<p>第一段和为6，第2段和为9，第3段和为1，和最大值为9。</p>
<p>将其如下分段：[4][2 4][5 1]</p>
<p>第一段和为4，第2段和为6，第3段和为6，和最大值为6。</p>
<p>并且无论如何分段，最大值不会小于6。</p>
<p>所以可以得到要将数列4 2 4 5 1要分成3段，每段和的最大值最小为6。</p>
<h3>Input Format</h3>
<p>输入的第1行包含两个正整数N，M，第2行包含N个空格隔开的非负整数A[i]，含义如题目所述。</p>
<h3>Output Format</h3>
<p>输出仅包含一个正整数，即每段和最大值最小为多少。</p>
<h3>Sample Input</h3>
<pre class="prettyprint linenums">5 3<br />
4 2 4 5 1
</pre>
<h3>Sample Output</h3>
<pre class="prettyprint linenums">6</pre>
<h3>Hint</h3>
<p>对于20%的数据，有N&le;10；</p>
<p>对于40%的数据，有N&le;1000；</p>
<p>对于100%的数据，有N&le;100000，M&le;N， A[i]之和不超过5.1*10^9。</p>
<h2>题解</h2>
<p>遇到&ldquo;最大值最小&rdquo;、&ldquo;最小值最大&rdquo;的题目往往采用二分答案的方法。二分区间应该是[Max{A[i]},Sigma(A[i])]。用Mid当做最大值进行判定，若分的组数大于M，说明Mid &lt; Ans，则L = Mid + 1；否则，分的组数小于等于M，说明Mid &gt;= Ans，那么R = Mid。注意每次得到判定结果后要分析Mid和Ans的关系，来判断每次L和R的变化。</p>
<h2>代码</h2>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 #include &lt;iostream&gt;<br />
 #define MAXN 100010<br />
 using namespace std;

 int N, M;<br />
 long long A[MAXN];<br />
 long long L, R, Mid;

 int Max(int A, int B) {<br />
     return A &gt; B ? A : B;<br />
 }

 bool Judge(int X) {<br />
     long long Sum = ;<br />
     int Cnt = ;<br />
     for (int i = ; i &lt;= N; ++i) {<br />
         if (Sum + A[i] &gt; X) {<br />
             ++Cnt;<br />
             Sum = A[i];<br />
         }<br />
         else Sum += A[i];<br />
     }<br />
     return Cnt &gt; M;<br />
 }

 int main() {<br />
     scanf("%d%d", &amp;N, &amp;M);<br />
     for (int i = ; i &lt;= N; ++i) {<br />
         scanf("%lld", &amp;A[i]);<br />
         L = Max(A[i], L);<br />
         R += A[i];<br />
     }<br />
     while (L &lt; R) {<br />
         Mid = (L + R) &gt;&gt; ;<br />
         if (Judge(Mid)) L = Mid + ;<br />
         else R = Mid;<br />
     }<br />
     printf("%d\n", L);<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93xxdg9.html">ArcGIS Engine开发之地图基本操作（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwnxyq.html">jmc远程监控java服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9337xn9.html">firefox的plugin-container进程关闭方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw4pe8.html">&lbrack;ACM&lowbar;几何&rsqb; Fishnet</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rw6x7q.html">【OpenWRT之旅】如何自定义一个配置文件的设置界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvozy18.html">2012多校3&period;A（用O&lpar;log&lpar;n&rpar;&rpar;判断b&Hat;k &percnt; a &equals;&equals; 0）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7k27k9.html">Sass学习之路&lpar;1&rpar;&mdash;&mdash;Sass简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6w418.html">Java基础-数据类型int，short，char，long，float，double，boolean，byte</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnm4d9.html">夺命雷公狗---2016-linux---1之ip的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0m3zeq.html">006--VS2013 C&plus;&plus; 加载其他格式图片&comma;并显示半透明化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmk7x19.html">P1011 传纸条&sol;&sol;dp优化改进状态表示</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1pzyv9.html">js 中特殊形势的函数-匿名函数的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1pg08.html">HDOJ 2018 母牛的故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzk3xl8.html">手机端调用app导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj74yl8.html">Java安装及基础01</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjpzr79.html">vue 打包后本地先自己启动服务 anywhere 非常好用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gpnr0q.html">神烦之float</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rd3v39.html">sql里的正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2kzroq.html">selenium case报错重新执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zw639.html">Windows核心编程：第10章 同步设备IO与异步设备IO</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1zxoo59.html">JavaScript正则验证数字、英文、电话号、身份证号、邮箱地址、链接地址等</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1ze039.html">Oracle分区表学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxngvr08.html">JSP标准标签库的安装以及自定义标签的创建</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v56p48.html">SGU 111&period;Very simple problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd3z6gq.html">SGU 170&period;Particles</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxng7vd8.html">javascript--自己用的插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdevnl09.html">Java compile时，提示 DeadCode的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxngpm08.html">Oracle数据库之PL&sol;SQL触发器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w1orlq.html">关于jQuery的cookies插件2&period;2&period;0版设置过期时间的说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1zw079.html">解决IE6不支持position&colon;fixed&semi;的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
